import rhinoscriptsyntax as rs
import extruder_turtle
from extruder_turtle import *

# Set up the turtle and associate it with a specific printer
t = ExtruderTurtle()
t.setup(x=0, y=0, z=0.0, filename=file, printer="ender")

# Print out important printer parameters
t.print_printer_information()

# Function definitions
def polygon_step(size, angle):
    t.forward(size)
    t.right(angle)

# Main part of the program
layer_height = t.get_layer_height()

#shape 0
size = 20
angle = 93  # Reduced the angle for a different pattern
for i in range(300):  # Increased the iterations for more complexity
    polygon_step(size, angle)
    t.lift(layer_height / (360 / angle))
    size = size + layer_height  # Adjusted size change for variation


# Visualize the turtle's location and position
turtle = t.draw_turtle()

# Visualize the printer's print bed
print_bed = t.draw_print_bed()

# Get the path the turtle has traveled to visualize in Rhino
lines = t.get_lines()

# Get print time and print it
time = t.get_print_time()
print("Approximate print time in minutes: " + str(time))

# Close the generated .gcode file
t.finish()