import rhinoscriptsyntax as rs
import extruder_turtle
from extruder_turtle import *

# Set up the turtle and associate it with a specific printer
t = ExtruderTurtle()
t.setup(x=0, y=0, z=0.0, filename=file, printer="ender")

# Print out important printer parameters
t.print_printer_information()

# Function definitions
def polygon_step(size, angle):
    t.forward(size)
    t.right(angle)

# Main part of the program
layer_height = t.get_layer_height()

#shape 0
size = 100  # Reduced size for smaller pattern
angle = 160  # Adjusted angle for a unique shape
for i in range(250):  # Increased iterations for complexity
    polygon_step(size, angle)
    t.lift(2 * layer_height / (360 / angle))  # Increased lift height to go higher
    size = size + layer_height  # Adjusted size change for variation




# Visualize the turtle's location and position
turtle = t.draw_turtle()

# Visualize the printer's print bed
print_bed = t.draw_print_bed()

# Get the path the turtle has traveled to visualize in Rhino
lines = t.get_lines()

# Get print time and print it
time = t.get_print_time()
print("Approximate print time in minutes: " + str(time))

# Close the generated .gcode file
t.finish()