import rhinoscriptsyntax as rs
import extruder_turtle
from extruder_turtle import ExtruderTurtle

# Set up the turtle
t = ExtruderTurtle()
t.setup(x=0, y=0, z=0.0, filename="spiral.gcode", printer="ender")

# Print out important printer parameters
t.print_printer_information()

# Main part of the program
layer_height = t.get_layer_height()
z_increment = 0.5  # Adjust the Z-axis increment to control the spiral pitch
z_max = 10.0  # Set the maximum Z-axis height within the printer's range
rotation_angle = 10  # Angle of rotation per step

for i in range(layers):
    # Draw a spinning and spiraling shape
    for j in range(number_sides):
        t.forward(size)
        t.right(360/number_sides)
        t.left(rotation_angle)  # Rotate the turtle by the specified angle
        t.lift(z_increment)  # Move the nozzle up by the specified increment
        if t.z > z_max:
            t.z = z_max  # Limit the Z-axis height to the printer's maximum
    t.lift(layer_height)  # Move the nozzle to the next layer

# Visualize the location and position of the turtle
turtle = t.draw_turtle()

# Visualize the printer's print bed
print_bed = t.draw_print_bed()

# Get the path traveled by the turtle to visualize in Rhino
lines = t.get_lines()

# Get print time for the turtle
time = t.get_print_time()
print("Approximate print time in minutes: " + str(time))

# Close the generated .gcode file
t.finish()